// Tech debt
// remove onClear()
// в WatcherForProps пробросить массив всех полей без deep: true
// remove changedInputs
// remove all unnecessary variable
// компонент submenu сделать prop :steps
<template>
  <cabinet-layout nav-active="profile">
    <div
      slot="block-content"
      class="wrench"
      v-if="auth">
      <submenu
        item-active="profile"
        :disable-leave="!isChangesSaved"/>
      <div class="ui form">
        <div class="container">
          <div class="title-mobile">Настройки. Мой профиль</div>
          <div class="column contacts">
            <div class="title">
              Контактная информация
              <div class="question">
                <div
                  class="button"
                  v-tooltip="{
                    classes: 'tooltip kit white',
                    trigger: 'hover',
                    offset: '4',
                    placement: 'right',
                    html: 'true',
                    content: `<div class=help-cabinet>
                                <p>Данные доступны только администратору GISAUTO.RU для связи с владельцем личного
                                кабинета в случае возникновения такой необходимости.</p>
                                </div>`,
                }" />
              </div>
            </div>
            <div
              class="field"
              :class="{invalid: validation.hasError('user.lastName')}">
              <label class="label">Фамилия</label>
              <div
                class="ui icon input"
                :class="{'filled-blue': changedInputs.lastName && isPhoneValid}">
                <input
                  type="text"
                  placeholder="Введите вашу фамилию"
                  v-model="user.lastName"
                  :class="{'filled-blue': changedInputs.lastName}"
                  id="lastName"
                  @input="checkChange('lastName')">
                <i
                  class="link advanced icon remove"
                  v-erase-control="user.lastName"
                  @click="onClear('lastName')"/>
              </div>
              <div
                v-if="validation.hasError('user.lastName')"
                class="error message">
                {{ validation.firstError('user.lastName') }}
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('user.firstName')}">
              <label class="label">Имя <span class="red">*</span></label>
              <div
                class="ui icon input"
                :class="{'filled-blue': changedInputs.firstName}">
                <input
                  type="text"
                  placeholder="Введите ваше имя"
                  v-model="user.firstName"
                  @input="checkChange('firstName')">
                <i
                  class="link advanced icon remove"
                  v-erase-control="user.firstName"
                  @click="onClear('firstName')"/>
              </div>
              <div
                v-if="validation.hasError('user.firstName')"
                class="error message">
                {{ validation.firstError('user.firstName') }}
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('user.middleName')}">
              <label class="label">Отчество</label>
              <div
                class="ui icon input"
                :class="{'filled-blue': changedInputs.middleName}">
                <input
                  type="text"
                  placeholder="Введите ваше отчество"
                  v-model="user.middleName"
                  :class="{'filled-blue': changedInputs.middleName}"
                  @input="checkChange('middleName')">
                <i
                  class="link advanced icon remove"
                  v-erase-control="user.middleName"
                  @click="onClear('middleName')"/>
              </div>
              <div
                v-if="validation.hasError('user.middleName')"
                class="error message">
                {{ validation.firstError('user.middleName') }}
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('user.phone')}">
              <label class="label">
                Телефон
                <span
                  v-if="phoneOptions.validationRule.isRequired"
                  class="red">*</span>
              </label>
              <div :class="{ 'block-input-btn': isPhoneConfirmable }">
                <AppInputPhone
                  :value="user.phone"
                  :options="phoneOptions"
                  :composite="false"
                  @input="changePhoneNumber"
                  @has-error="phoneMaskHasError = $event"
                  :class="{
                    'filled-blue': changedInputs.phone,
                    'button-right': isPhoneConfirmable,
                  }"
                  :only-mobile="false" />
                <button
                  v-if="isPhoneConfirmable"
                  class="ui button blue small"
                  :class="{'loading': isLoading}"
                  :disabled="phone.disabled || !isPhoneValid"
                  @click="confirmedPhoneNumber">Подтвердить
                </button>
              </div>
              <!-- <div
                v-if="validation.hasError('user.phone')"
                class="error message">
                {{ validation.firstError('user.phone') }}
              </div> -->
            </div>

            <div class="field">
              <label class="label">Город <span class="red">*</span></label>
              <city-search
                v-model="user.city"
                :class="{'filled-blue': changedInputs.city, invalid: validation.hasError('user.city')}"
                @input="checkChange('city')"
                placeholder="Поиск города"/>
              <div
                v-if="validation.hasError('user.city')"
                class="error message">
                {{ validation.firstError('user.city') }}
              </div>
            </div>
          </div>

          <div class="column account">
            <div class="title">
              Учетная запись
              <div class="question">
                <div
                  class="button"
                  v-tooltip="{
                    classes: 'tooltip kit white',
                    trigger: 'hover',
                    offset: '4',
                    placement: 'right',
                    html: 'true',
                    content: '<div class=help-cabinet>' +
                      '<p>Данные для авторизации на GISAUTO.RU</p>' +
                      '</div>',
                }"/>
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('user.username')}">
              <label class="label">E-mail <span class="red">*</span></label>
              <div
                :class="{'block-input-btn': !email.isConfirmed &&
              (!changedInputs.username || changedInputs.username === null)}">
                <div
                  class="ui icon input"
                  :class="{'filled-blue': changedInputs.username}">
                  <input
                    type="email"
                    :placeholder="user.username || 'E-mail'"
                    :disabled="!showPasswordFields || email.disabled"
                    id="user.username"
                    name="username"
                    @input="checkChange('username')"
                    v-model="user.username">
                  <i
                    class="link advanced icon remove"
                    v-erase-control="user.username"
                    @click="onClear('username')"/>
                </div>
                <button
                  v-if="!email.isConfirmed && (!changedInputs.username || changedInputs.username === null)"
                  class="ui button blue small"
                  :class="{'loading': isLoading}"
                  @click="confirmEmail">Подтвердить
                </button>
              </div>
              <div
                v-if="validation.hasError('user.username')"
                class="error message">
                {{ validation.firstError('user.username') }}
              </div>
            </div>

            <div
              class="field"
              :class="{invalid: validation.hasError('password.old')}">
              <label class="label">Пароль <span
                v-if="showPasswordFields"
                class="red">*</span></label>
              <div class="ui icon input">
                <input
                  type="password"
                  v-model="password.old"
                  :placeholder="showPasswordFields ? 'Введите действующий пароль' : '*********'"
                  :disabled="!showPasswordFields"
                  minlength="6"
                  autocomplete="off"
                  id="password.old"
                  name="password.old">
                <i
                  class="link advanced icon eye"
                  v-if="showPasswordFields"
                  v-password-control="'password.old'"/>
                <i
                  class="link advanced icon remove"
                  v-erase-control="password.old"
                  @click="onClear('password.old')"/>
              </div>
              <div
                v-if="validation.hasError('password.old')"
                class="error message">
                {{ validation.firstError('password.old') }}
              </div>
              <span
                v-if="showPasswordFields"
                role="button"
                class="kit aqualink btn-reset-password"
                @click="showResetPasswordModal">Забыли пароль?</span>
            </div>

            <div
              v-if="!showPasswordFields"
              class="field edit-call"
              @click="editProfileFields">
              <button class="ui button inverted thin blue small fluid">Редактировать учетную запись</button>
            </div>
            <div v-if="showPasswordFields">

              <div
                class="field"
                :class="{invalid: validation.hasError('password.new')}">
                <label class="label">Новый пароль <span
                  v-if="isChangingPassword"
                  class="red">*</span></label>
                <div
                  class="ui icon input"
                  :class="{'filled-blue': changedInputs.newPassword}">
                  <input
                    type="password"
                    placeholder="Введите новый пароль"
                    minlength="6"
                    autocomplete="off"
                    id="password.new"
                    name="password.new"
                    @input="checkChange('newPassword')"
                    v-model="password.new">
                  <i
                    class="link advanced icon eye"
                    v-password-control="'password.new'"/>
                  <i
                    class="link advanced icon remove"
                    v-erase-control="password.new"
                    @click="onClear('newPassword')"/>
                </div>
                <div
                  v-if="validation.hasError('password.new')"
                  class="error message">
                  {{ validation.firstError('password.new') }}
                </div>
              </div>

              <div
                class="field"
                :class="{invalid: validation.hasError('password.repeat')}">
                <label class="label">Повторите пароль <span
                  v-if="isChangingPassword"
                  class="red">*</span></label>
                <div
                  class="ui icon input"
                  :class="{'filled-blue': changedInputs.passwordRepeat} ">
                  <input
                    type="password"
                    placeholder="Повторите пароль"
                    minlength="6"
                    autocomplete="off"
                    id="password.repeat"
                    name="password.repeat"
                    @input="checkChange('passwordRepeat')"
                    v-model="password.repeat">
                  <i
                    class="link advanced icon eye"
                    v-password-control="'password.repeat'"/>
                  <i
                    class="link advanced icon remove"
                    v-erase-control="password.repeat"
                    @click="onClear('passwordRepeat')"/>
                </div>
                <div
                  v-if="validation.hasError('password.repeat')"
                  class="error message">
                  {{ validation.firstError('password.repeatpassword.repeat') }}
                </div>
              </div>

            </div>
          </div>

          <div
            class="block-organizations"
            v-if="auth.isOrganization">
            <div class="text">
              Для того чтобы настроить получение уведомлений с портала пройдите в раздел
              <flink
                class="kit aqualink"
                href="/cabinet/wrench/notification-setup">Настройка уведомлений</flink>.
            </div>
            <div class="text">
              Для того чтобы получать запросы от покупателей, необходимо настроить
              <flink
                class="kit aqualink"
                href="/cabinet/inbox/settings">Входящие запросы</flink>.
            </div>
            <div
              class="text"
              v-if="auth.isOrganizationWithShop && auth.organizationSended">
              Для того чтобы покупатели могли купить у вас запчасть,
              <flink
                class="kit aqualink"
                href="/cabinet/price-upload/upload">загрузите прайс-лист</flink>.
            </div>
          </div>

          <div
            class="error message"
            v-if="error">
            {{ error }}
          </div>

          <div class="block-btn">
            <button
              type="submit"
              class="ui button yellow btn-save-change"
              :class="{ disabled: !isPropChanged, loading: isLoading }"
              :disabled="disableSaveChangeButton"
              @click="defaultSave">
              Сохранить изменения
            </button>
          </div>
        </div>
      </div>
    </div>

    <div slot="line-modal">
      <verify-phone
        v-model="modals.phone"
        :is-counting="phoneCountDownStarted"
        :error-message="phoneError"
        @input="confirmVerifyCode($event, {data: user.phone, type: 'phone'})"
        @sendAgain="confirmedPhoneNumber"
        @timeIsUp="onPhoneNumberConfirmedState"
        @close="closePhoneVerify"/>
      <verify-mail
        v-model="modals.email"
        @input="confirmVerifyCode($event, {data: user.username, type: 'email'})"
        @sendAgain="confirmEmail"
        @close="closeEmailVerify"
        :error-message="emailError"/>
      <exit-save
        v-model="modals.exitSave"
        :has-errors="hasError"
        :link="goToPath"
        @save="saveAndGo"/>
    </div>

  </cabinet-layout>
</template>

<script>
import {
  has,
  get,
  map,
  mapValues,
} from 'lodash-es';
import { createNamespacedHelpers } from 'vuex';
import { SHOW } from '~/assets/js/store/infoModal/action-types';
import { SET_USER } from '~/assets/js/store/user/mutation-types';
import { SHOW_RESET_PASSWORD_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import SimpleVueValidation from 'simple-vue-validator';
import Validator from '~/assets/js/validator';
import Multiselect from 'vue-multiselect';

import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import Submenu from '~/components/redesign/cabinet/submenu';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import CitySearch from '~/components/redesign/blocks/citySearch';

import VerifyPhone from '~/components/redesign/cabinet/modal/verify-phone';
import VerifyMail from '~/components/redesign/cabinet/modal/verify-mail';
import ExitSave from '~/components/redesign/cabinet/modal/exit-save';

import WatcherForProps from '~/assets/js/mixins/watcherForProps';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
    match: 'Пароли должны совпадать.',
  },
});

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'WrenchProfile',
  components: {
    CabinetLayout,
    Submenu,
    Multiselect,
    AppInputPhone,
    CitySearch,
    VerifyPhone,
    VerifyMail,
    ExitSave,
  },
  mixins: [WatcherForProps(['user', 'password'], { deep: true })],
  layout: 'cabinet',
  data() {
    return {
      goToPath: '',
      user: {
        lastName: get(this.$store.state.user.auth.userProfile, 'lastName', ''),
        firstName: get(this.$store.state.user.auth.userProfile, 'firstName', ''),
        middleName: get(this.$store.state.user.auth.userProfile, 'middleName', ''),
        phone: get(this.$store.state.user.auth.userProfile, 'phone', ''),
        username: get(this.$store.state.user.auth, 'username', ''),
        city: get(this.$store.state.user.auth.userProfile, 'city', {}) || {},
      },
      password: {
        old: '',
        new: '',
        repeat: '',
      },
      phone: {
        isConfirmed: false,
        disabled: false,
      },
      email: {
        isConfirmed: false,
        disabled: false,
      },
      changedInputs: {
        lastName: null,
        firstName: null,
        middleName: null,
        oldPassword: null,
        newPassword: null,
        passwordRepeat: null,
        phone: null,
        username: null,
        city: null,
      },
      phoneCountDownStarted: false,
      showPasswordFields: false,
      rememberMe: null,
      isLoading: false,
      error: false,
      editAccountError: false,
      phoneMaskHasError: false,
      modals: {
        phone: false,
        email: false,
        exitSave: false,
      },
      phoneError: '',
      emailError: '',
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    ...STORE_USER.mapGetters(['userProfileDone']),
    isPhoneConfirmable() {
      return this.user.phone
        && !this.phone.isConfirmed
        && (!this.changedInputs.phone || this.changedInputs.phone === null)
        && Validator.isMobilePhoneNumber(this.user.phone);
    },
    phoneOptions() {
      return {
        noIcon: true,
        validationRule: {
          isRequired: this.auth.isOrganization,
          isMobile: false,
          isUnique: false,
        },
      };
    },
    valid() {
      return Validator.notBlank(this.user.firstName)
          && Validator.notBlank(this.user.city.id)
          && (!this.phoneOptions.validationRule.isRequired || Validator.notBlank(this.user.phone));
    },
    hasError() {
      return this.validation.errors.length > 0;
    },
    isAccountEdited() {
      return this.changedInputs.username || this.changedInputs.newPassword;
    },
    isChangingPassword() {
      return this.changedInputs.newPassword || this.changedInputs.passwordRepeat;
    },
    isChangesSaved() {
      return map(this.changedInputs, (item, key) => !item || key === 'newPassword').every(item => item);
    },
    isPhoneValid() {
      return !this.validation.errors.find(error => error.field === 'user.phone');
    },
    isEmailValid() {
      return !this.validation.errors.find(error => error.field === 'user.username');
    },
    disableSaveChangeButton() {
      return !this.isPropChanged || this.isLoading || this.hasError || this.phoneMaskHasError
          || (this.isChangingPassword && (!this.password.new || !this.password.repeat))
          || !this.valid;
    },
  },
  validators: {
    'user.firstName'(value) {
      return SimpleVueValidator.value(value).required();
    },
    'user.city'(value) {
      return SimpleVueValidator.value(value).required().custom(() => {
        if (Object.keys(value).length === 0) {
          return 'Выберите город';
        }
        return '';
      });
    },
    'user.username'(value) {
      return SimpleVueValidator.value(value).required().email();
    },
    'user.phone'(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (!Validator.notBlank(value) && !this.phoneOptions.validationRule.isRequired) {
          return '';
        }
        if (!Validator.checkPhone(value)) {
          return 'Введите корректный номер телефона';
        }
        return '';
      });
    },
    'password.old'(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (this.isAccountEdited && !value) {
          return 'Введите пароль';
        }
        return '';
      });
    },
    'password.new, password.repeat'(password, repeat) {
      return SimpleVueValidator.value(repeat).match(password);
    },
  },
  head() {
    return {
      title: 'Личный кабинет - Настройка - Мой профиль',
    };
  },
  watch: {
    'user.phone'() {
      this.phoneCountDownStarted = false;
    },
  },
  created() {
    this.phone.isConfirmed = get(this.auth.userProfile, 'confirmedPhone', false);
    this.email.isConfirmed = get(this.auth.userProfile, 'confirmedEmail', false);
  },
  mounted() {
    document.addEventListener('mousedown', this.onLeaveBeforeSave);
  },
  destroyed() {
    document.addEventListener('mousedown', this.onLeaveBeforeSave);
    this.goToPath = '';
    this.resetChangedInputs();
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showResetPasswordModal: SHOW_RESET_PASSWORD_MODAL,
    }),
    ...STORE_USER.mapMutations({
      setUser: SET_USER,
    }),
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    editProfileFields() {
      this.showPasswordFields = true;
      this.email.disabled = false;
    },
    changePhoneNumber(value) {
      this.user.phone = value;
      this.checkChange('phone');
    },
    checkChange(key) {
      if (!this.auth) {
        return;
      }

      const { userProfile } = this.auth;

      if (userProfile && has(userProfile, key)) {
        if (key === 'city') {
          if (has(userProfile.city, 'id')) {
            this.changedInputs.city = userProfile.city.id !== this.user.city.id;
          } else {
            this.changedInputs.city = true;
          }

          return;
        }

        this.changedInputs[key] = userProfile[key] !== this.user[key];
      } else {
        switch (key) {
          case 'username':
            this.changedInputs.username = this.auth.username !== this.user.username;
            break;
          case 'newPassword':
            this.changedInputs[key] = Boolean(this.password.new);
            break;
          case 'passwordRepeat':
            this.changedInputs[key] = Boolean(this.password.repeat);
            break;
          default:
            this.changedInputs[key] = Boolean(this.user[key]);
        }
      }
    },
    async saveChangesRequest() {
      const isValid = await this.$validate();

      if (!isValid) {
        return false;
      }

      this.isLoading = true;

      const { city, ...rest } = this.user;

      const reqPayload = Object.assign({}, rest, {
        cityId: parseInt(city.id, 10),
      });

      if (this.isAccountEdited) {
        if (this.password.old) {
          reqPayload.oldPassword = this.password.old;
        }

        if (this.password.new) {
          reqPayload.password = this.password.new;
        }
      }

      const response = await this.$axios
        .$post('/_main/user/update', reqPayload)
        .catch((e) => {
          this.isLoading = false;

          switch (e.response.data.error.errorType) {
            case 'duplicate email':
              this.showInfo({
                text: `Указанный e-mail принадлежит другому Пользователю.</br>Cвяжитесь с Вашим менеджером
                  или тех.поддержкой.`,
                buttonVisibility: true,
                buttonText: 'Написать в тех.поддержку',
                buttonUrl: '/about-us/contacts',
              });
              break;
            case 'duplicate phone number':
              this.showInfo({
                text: `Указанный номер телефона принадлежит другому Пользователю.</br>Cвяжитесь с Вашим менеджером
                  или тех.поддержкой.`,
                buttonVisibility: true,
                buttonText: 'Написать в тех.поддержку',
                buttonUrl: '/about-us/contacts',
              });
              break;
            default:
              this.showInfo({
                text: e.response.data.message,
                buttonVisibility: false,
              });
          }

          console.error(e.response.data.message);
        });

      this.isLoading = false;

      if (response && response.data) {
        this.setUser(response.data);
        this.resetChangedInputs();
        this.validation.reset();
      }

      return response && response.data;
    },
    async defaultSave() {
      const data = await this.saveChangesRequest();

      if (data) {
        // TODO: Как только будет готов новый фронт, window.location.href заменим
        // на this.$router.push()
        window.location.href = this.auth.isOrganization
          ? '/cabinet/wrench/organization-info'
          : '/cabinet/wrench/notification-setup';
      }
    },
    onClear(key) {
      setTimeout(() => {
        this.checkChange(key);
      }, 0);
    },
    onLeaveBeforeSave(e) {
      const link = e.target.closest('a');

      if (!link) {
        return;
      }

      if (link.target === '_blank') {
        return;
      }

      if (!this.isChangesSaved) {
        this.showSaveNotification();
        this.goToPath = link.pathname;
      }
    },
    resetChangedInputs() {
      this.changedInputs = mapValues(this.changedInputs, () => false);
    },
    async saveAndGo() {
      const data = await this.saveChangesRequest();

      if (data) {
        window.location.href = this.goToPath;
      }
    },
    async requestToConfirmEmail() {
      this.email.disabled = true;
      this.isLoading = true;

      try {
        const { data } = await this.$axios.$post('/_main/user/sendEmailToConfirm', { email: this.user.username });

        this.email.disabled = false;
        this.isLoading = false;

        return data || null;
      } catch (error) {
        this.isLoading = false;

        if (!this.modals.email) {
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
        } else {
          this.emailError = error.response.data.message;
        }

        console.error(error.response.data.message);
      }

      return null;
    },
    async confirmEmail() {
      if (!this.isEmailValid) {
        return;
      }

      const data = await this.requestToConfirmEmail();

      if (data && data.success) {
        this.showVerifyEmail();
      }
    },
    closeEmailVerify() {
      this.email.disabled = false;
      this.emailError = '';
    },
    async requestToConfirmPhoneNumber() {
      try {
        const { data } = await this.$axios.$post('/_main/user/sendPhoneToConfirm', {
          phone: this.user.phone,
        });

        return data;
      } catch (error) {
        this.phone.disabled = false;

        if (error.response.status === 502) {
          this.showVerifyPhoneModal();
          this.phoneCountDownStarted = true;
          this.phone.disabled = false;
          return false;
        }

        if (!this.modals.phone) {
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
        } else {
          this.phoneError = error.response.data.message;
        }
      }

      return false;
    },
    async confirmedPhoneNumber() {
      this.phone.disabled = true;

      if (this.phoneCountDownStarted) {
        this.showVerifyPhoneModal();
        return;
      }

      try {
        const data = await this.requestToConfirmPhoneNumber();

        if (data && data.success) {
          this.showVerifyPhoneModal();
          this.phoneCountDownStarted = true;
          this.phone.disabled = false;
        }
      } catch (e) {
        this.phone.disabled = false;
        console.log(e);
      }
    },
    /**
       * В опциях type передается конкретный тип поля для подтверждения
       * @param code
       * @param options {data: String, type: String}
       * @returns {Promise<{data: {success: boolean}}>}
       */
    async confirmVerifyCode(code, options) {
      const errorMessage = `${options.type}Error`;

      const request = { code };

      this[errorMessage] = '';
      this[`${options.type}ButtonDisabled`] = true;

      request[options.type] = options.data;

      try {
        const { data } = await this.$axios.$post(`/_main/user/confirm${options.type}`, request);

        if (data && data.success) {
          this.modals[options.type] = false;
          this[options.type].isConfirmed = true;
          this[options.type].disabled = true;
          this.changedInputs.username = false;
          this.saveChangesRequest();
        }
      } catch (e) {
        this[errorMessage] = e.response.data.message;
        console.error(e.response.data.message);
      }
    },
    onPhoneNumberConfirmedState() {
      this.phone.disabled = false;
      this.phoneCountDownStarted = false;
    },
    closePhoneVerify() {
      this.phone.disabled = false;
      this.phoneError = '';
    },
    showSaveNotification() {
      this.modals.exitSave = true;
    },
    showVerifyPhoneModal() {
      this.modals.phone = true;
    },
    showVerifyEmail() {
      this.modals.email = true;
    },
  },
};
</script>

<style>
  .kit.locations.select.invalid .multiselect__tags {
    border-color: #e13c3c!important;
  }
</style>

<style scoped lang="postcss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        padding: 0;
        min-height: auto;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;

        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .wrench {
    display: flex;
    flex-flow: column nowrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 100%;

    .container {
      display: flex;
      flex-flow: row wrap!important;
      justify-content: flex-start;
      align-items: flex-start;
      padding: 1.5rem;
      @media screen and (max-width: 980px) {
        padding: 1.5rem 1rem;
        flex-flow: column nowrap;
      }

      .column {
        @media screen and (max-width: 980px) {
          display: flex;
          flex-flow: column nowrap;
          justify-content: flex-start;
          align-items: stretch;
          flex: 1 0 auto;
          width: 100%;
          max-width: 28rem;
          margin: 0;
          + .column {
            padding-top: 2rem;
          }
        }
        @media screen and (min-width: 981px) {
          display: block;
          flex: 0 1 22rem;
          width: 22rem;
          + .column {
            margin-left: 4.5rem;
          }
        }
      }

      .title-mobile {
        @media screen and (max-width: 980px) {
          width: 100%;
          display: block;
          font-size: 1.125rem;
          font-weight: 700;
          padding: 0 0 1.5rem;
        }
        @media screen and (min-width: 981px) {
          display: none;
        }
      }

      .title {
        display: block;
        font-size: 1rem;
        line-height: 1;
        @media screen and (max-width: 980px) {
          padding: 0 0 1rem;
          font-weight: 500;
        }
        @media screen and (min-width: 981px) {
          font-weight: 700;
          padding: 0 1rem 1rem;
        }

        .question {
          margin-left: 0.5rem;
        }
      }

      .block-input-btn {
        display: flex;
        flex-flow: row nowrap;
        justify-content: space-between;
        align-items: stretch;

        .button-right+.ui.button {
          max-height: 100%;
        }

        .ui.input {
          flex: 0 1 auto;
        }

        .ui.button {
          position: relative;
          margin-left: 0;
          margin-right: 0;
          border-top-left-radius: 0;
          border-bottom-left-radius: 0;
        }

        @media screen and (max-width: 479px) {
          flex-flow: column nowrap;
          .ui.button {
            font-size: 0.875rem;
            margin: 0;
            border-top-left-radius: 0;
            border-top-right-radius: 0;
            border-bottom-left-radius: 0.25rem;
            max-height: none;
          }
          .ui.input {
            width: 100%;

            > input {
              border-bottom-left-radius: 0;
              border-bottom-right-radius: 0;
            }
          }
        }
        @media (min-width: 480px) and (max-width: 980px) {
          .ui.button {
            flex: 1 0 8rem;
            font-size: 0.875rem;
          }
          .ui.input {
            max-width: calc(100% - 8rem);

            > input {
              border-top-right-radius: 0;
              border-bottom-right-radius: 0;
            }
          }
        }
        @media screen and (min-width: 981px) {
          .ui.button {
            flex: 1 0 7.5rem;
          }
          .ui.input {
            max-width: calc(100% - 7.5rem);

            > input {
              border-top-right-radius: 0;
              border-bottom-right-radius: 0;
            }
          }
        }
      }

      .field {
        position: relative;
        width: 100%;

        .label {
          @media screen and (max-width: 980px) {
            display: none;
          }
        }

        input[disabled] + i.icon {
          pointer-events: none;
        }
      }

      .field .btn-reset-password {
        @media screen and (max-width: 980px) {
          display: inline-block;
          width: auto;
          padding-top: 0.5rem;
          float: right;
        }
        @media screen and (min-width: 981px) {
          position: absolute;
          left: 100%;
          bottom: 0.25rem;
          margin-left: 1rem;
          font-size: 0.8125rem;
          white-space: nowrap;
        }
      }

      .field.edit-call {
        @media screen and (min-width: 981px) {
          padding-top: 1.25rem;
        }
      }

      .block-organizations {
        display: block;
        width: 100%;
        padding: 1rem 0 0;

        .text {
          display: block;
          font-size: 0.8125rem;
          line-height: 1.5;
          font-weight: 400;
          padding-bottom: 0.625rem;
        }

        @media screen and (max-width: 980px) {
          .text {
            font-size: 0.875rem;
          }
        }
      }

      .block-btn {
        display: block;
        width: 100%;

        .btn-save-change {
          @media screen and (max-width: 980px) {
            width: 100%;
            max-width: 28rem;
            margin: 0.625rem 0 0;
          }
          @media screen and (min-width: 981px) {
            margin-top: 1rem;
            font-size: 0.875rem;
          }
        }
      }
    }
  }

  .ui.input.invalid > input,
  .ui.input.invalid > input[type=tel] {
    border-color: #e13c3c !important;
  }

</style>
